/*
  fast-exponentiation-test.c

  Uses the square and multiply algorithm for fast exponentation

  Part of my implementation of the RSA scheme
*/

#include <stdio.h> // printf
#include <stdlib.h> // atol
#include "exponentiation.h"

int main (int argc, char ** argv)
{
  unsigned long int p = 0, q = 0, m = 0;

  if (argc != 4)
    {
      fprintf (stderr, "You must specify p, q and m on the command line.\n");
      return 1;
    }
  
  p = atol (argv [1]);
  q = atol (argv [2]);
  m = atol (argv [3]);

  printf ("%lu^%lu (mod %lu) = %lu\n", p, q, m, exponentiate (p, q, m));

  return (0);
}
